own mailserver, lots of improvements
[distro-setup] / distro-begin
1 #!/bin/bash -l
2 # Copyright (C) 2016 Ian Kelling
3 #
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at
7 #
8 # http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16
17
18
19 # for bootstrapping a new machine
20
21 # in case we need it,
22 # to make ssh interactive shell run better, we run this first.
23 sudo bash -c 'source /a/c/repos/bash/.bashrc && source /a/exe/ssh-emacs-setup'
24
25
26 # usage: $0 [-r] HOSTNAME
27
28 # tips:
29 # run any sudo command first so your pass is cached
30 # set the scrollback to unlimited in case something goes wrong
31
32 if [[ $EUID == 0 ]]; then
33 if getent passwd ian; then
34 echo "$0: error: running as root. unprivileged user exists. use it."
35 exit 1
36 else
37 echo "$0: warning: running as root. I will setup users then exit"
38 fi
39 fi
40
41 interactive=true # set this to false to force set -x
42 [[ $- == *i* ]] || interactive=false
43
44 if ! $interactive; then
45 set -x
46 set -e -o pipefail
47 fi
48 set -E
49 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?"' ERR
50
51 exec &> >(sudo tee -a /var/log/distro-begin)
52 echo "$0: $(date): starting now)"
53
54 # headless=false # unused atm
55 recompile=false
56 # for copying to a new data fs
57 bootstrapfs=false # old flag, needs new look before using.
58 while [[ $1 == -* ]]; do
59 case $1 in
60 -r) recompile=true; shift ;;
61 esac
62 done
63
64 if [[ $1 ]]; then
65 export HOSTNAME=$1
66 fi
67
68 for f in iank-dev htpc treetowl x2 frodo tp li lj demohost; do
69 eval "$f() { [[ $HOSTNAME == $f ]]; }"
70 done
71 has_p() { treetowl || x2 || frodo || tp || demohost; }
72 has_x() { ! linode; }
73 linode() { lj || li; }
74 has_btrfs() { ! linode; }
75 home_network() { ! linode; }
76 encrypted() { has_p; }
77
78 shopt -s extglob
79 export GLOBIGNORE=*/.:*/..
80 umask 0002
81
82
83 ####### end command line parsing
84
85 PATH="/a/exe:$PATH"
86 sed="sed --follow-symlinks"
87
88 ##### begin setup encryption scripts ######
89 if encrypted; then
90 # I tried making a service which was dependent on reboot.target,
91 # but it happened too late in the shutdown process.
92 sudo dd of=/etc/systemd/system/keyscripton.service <<'EOF'
93 [Unit]
94 Description=Turn on automatic decryption of drives on boot
95 # tried using graphical.target, but it made my display manager restart before rebooting.
96 # generally, I don't think targets order shutdown like they do startup.
97 # So, I did systemd-analyze plot > something.svg, and picked a reliably started
98 # service that happens late in the game.
99 After=ntp.service
100 DefaultDependencies=no
101 # not sure if needed, makes sure we shut down before reboot.target
102 Conflicts=reboot.target
103
104 [Service]
105 Type=oneshot
106 RemainAfterExit=yes
107 ExecStart=/bin/true
108 ExecStop=/a/exe/keyscript-on
109
110 [Install]
111 WantedBy=keyscriptoff.service
112 EOF
113 sudo systemctl daemon-reload # needed if the file was already there
114 sudo systemctl stop keyscripton.service
115 # sudo systemctl start keyscripton.service
116 sudo systemctl enable keyscripton.service
117
118 sudo dd of=/etc/systemd/system/keyscriptoff.service <<'EOF'
119 [Unit]
120 Description=Turn off automatic decryption of drives on boot
121
122 [Service]
123 Type=oneshot
124 ExecStart=/a/exe/keyscript-off
125
126 [Install]
127 WantedBy=multi-user.target
128 EOF
129 sudo systemctl daemon-reload # needed if the file was already there
130 sudo systemctl enable keyscriptoff.service
131 sudo systemctl start keyscriptoff.service
132 fi
133 ##### end setup encryption scripts ######
134
135
136 install-myqueue
137
138 # this script has been designed to be idempotent
139 # todo, it would be nice to cut down on some of the output
140
141
142 for x in /a/bin/errhandle/*-function; do
143 source $x
144 done
145
146
147 set +e
148 $interactive || errcatch
149 set +x
150 source /a/bin/distro-functions/src/identify-distros
151 $interactive || set -x
152
153 if isfedora; then
154 # comment out line disallowing calling sudo in scripts
155 sudo $sed -i 's/^Defaults *requiretty/#\0 # ian commented/' /etc/sudoers
156 # turn on magic sysrq commands for this boot cycle
157 echo 1 > sudo dd of=/proc/sys/kernel/sysrq
158 # selinux is not user friendly. Like, you enable samba, but you haven't run the magic selinux commands so it doesn't work
159 # and you have no idea why.
160 sudo $sed -i 's/^\(SELINUX=\).*/\1disabled/' /etc/selinux/config
161 selinuxenabled && sudo setenforce 0
162 fi
163
164
165 # already ran for pxe installs, but used for vps & updates
166 distro=$(distro-name)
167 case $distro in
168 ubuntu|debian)
169 sudo bash -c ". /a/bin/fai/fai-wrapper && /a/bin/fai/fai/config/scripts/GRUB_PC/11-ian"
170 ;;
171 *)
172 sudo bash -c ". /a/bin/fai/fai-wrapper &&
173 /a/bin/fai/fai/config/distro-install-common/end"
174 ;;
175 esac
176
177 if linode; then
178 sudo $sed -i '/^127\.0\.1\.1/d' /etc/hosts
179 echo "127.0.1.1 $HOSTNAME.lan $HOSTNAME" | sudo tee -a /etc/hosts
180 fi
181
182
183 if [[ $EUID == 0 ]]; then
184 echo "$0: running as root. exiting now that users are setup"
185 exit 0
186 fi
187
188
189 #### begin link bashrc repo for all users ######
190 for x in /a/c/repos/bash/!(.git|..|.); do
191 lnf "$x" /home/ian
192 sudo -u traci -i <<EOF
193 PATH="/a/exe:$PATH"
194 lnf "$x" /home/traci
195 EOF
196 sudo -i <<EOF
197 PATH="/a/exe:$PATH"
198 lnf $x /root
199 EOF
200 done
201 #### end link bashrc repo for all users ######
202
203
204 set +x
205 errallow
206 source ~/.bashrc
207 $interactive || errcatch
208 $interactive || set -x
209
210
211 # passwordless sudo
212 tu /etc/sudoers <<'EOF'
213 ian ALL=(ALL) NOPASSWD: ALL
214 Defaults env_keep += SUDOD
215 EOF
216
217
218 # enable magic sysrq keys. debian docs say it is already enabled by default
219 isfedora && tu /etc/sysctl.conf 'kernel.sysrq = 1'
220
221
222 # this needs to be before installing pacserve so we have gpg conf.
223 conflink
224
225 if isdebian; then
226 codename=$(debian-codename)
227 if isdebian-stable && has_x; then
228 s dd of=/etc/apt/sources.list.d/mozilla-iceweasel.list <<EOF
229 deb http://mozilla.debian.net/ $codename-backports firefox-release
230 deb-src http://mozilla.debian.net/ $codename-backports firefox-release
231 EOF
232 p update
233 # take care of mozilla signing errors in previous command
234 pi pkg-mozilla-archive-keyring
235 p update
236 else
237 :
238 # this would change stable to testing, but I set that up already.
239 # It\'s just a no-op if its already testing.
240 # sudo sed -ri 's!^( *[^ #]+ +[^ ]+ +)[[:alpha:]]+(.*)!\1testing\2!' /etc/apt/sources.list
241 p update
242 fi
243 fi
244
245 if isarch; then
246 #https://wiki.archlinux.org/index.php/Arch_User_Repository#Installing_packages
247 sudo pacman -S --noconfirm --needed base-devel jq
248 # pacaur seems to be the best, although it + cower has a few minor bugs,
249 # its design goals seem good, so, going for it.
250
251 aurpi() {
252 for p in "$@"; do
253 tempdir=$(mktemp -d)
254 pushd $tempdir
255 aurex "$p"
256 makepkg -sri --skippgpcheck --noconfirm
257 popd
258 rm -rf $tempdir
259 done
260 }
261 aurpi cower pacaur
262
263 pi pacserve
264
265 x=$(mktemp); /usr/bin/pacman.conf-insert_pacserve >$x
266 sudo dd of=/etc/pacman.conf if=$x; rm $x
267 sudo systemctl enable pacserve.service
268 sudo systemctl start pacserve.service
269
270 # strange error if just installing trash-cli: "pyalpm requires python",
271 # so I see that it requires python2, and installing that manually fixes it.
272 # I didn't see this on earlier installation, main thing which changed was
273 # pacserve, so not sure if it's related.
274 pi python2
275 fi
276
277 pup
278 pi trash-cli
279
280
281 ###### link files ###########
282 # convenient to just do all file linking in one place
283
284 # if it wasn't set already, we could set hostname here
285 #echo treetowl | s dd of=/etc/hostname
286 #s hostname -F /etc/hostname
287 #HOSTNAME=$(hostname)
288
289
290 s lnf -T /a/bin /b
291
292 if has_p; then
293 lnf -T /p/News ~/News
294 fi
295
296 s lnf /q/root/.editor-backups /q/root/.undo-tree-history \
297 /a/opt /a/c/.emacs.d $HOME/mw_vars /k/backup /root
298
299 rootsshsync
300
301 s lnf /a/c/.inputrc /a/c/.vim /a/c/.vimrc /a/c/.gvimrc /root
302
303 # machine is going away
304 # if [[ $HOSTNAME == htpc ]]; then
305 # lnf -T /i/Videos ~/Downloads
306 # fi
307
308 if has_p; then
309 # for dovecot
310 lnf -T /i/k/mboxes ~/mail
311 fi
312
313
314 # basic needed packages
315 case $(distro-name) in
316 debian)
317 if has_x; then
318 if isdebian-stable; then
319 pi firefox/$codename-backports
320 else
321 # for a while, firefox/unstable did not have
322 # dependencies satisfied by testing packages, and i hit
323 # a conflict, it wanted a newer libfontconfig1, but
324 # emacs build-deps wanted an older one. In this case,
325 # I switch to using firefox-esr. note: They seem
326 # to release a new esr version every 9 months or so.
327 pi firefox/unstable
328 fi
329 fi
330 # for hosts which require nonfree drivers
331 # i previously had extra packages listed here linux-image-amd64
332 # firmware-linux-free linux-headers-amd64, but I
333 # don\'t see any reason why. seems to work in testing without.
334 # remove this note if it continues to work.
335 p=firmware-linux-nonfree
336 if apt-cache show $p &>/dev/null; then
337 pi $p
338 fi
339 ;;&
340 ubuntu|debian)
341 if has_x; then
342 if isdebian-stable; then
343 pi xmacro
344 else
345 pi xmacro/unstable # has no unstable deps
346 fi
347 pi gtk-redshift xinput
348 fi
349 ;;&
350 fedora)
351 p -y groupinstall development-tools c-development books admin-tools
352 pi wget man-pages
353 if has_x; then
354 pi redshift-gtk
355 # debian has this package patched to work, upstream is dead
356 # tried using alien, pi alien, alien -r *.deb, rpm -Uhv *.rpm, got this error, so fuck it
357 # file /usr/bin from install of xmacro-0.3pre_20000911-7.x86_64 conflicts with file from package filesystem-3.2-19.fc20.x86_64
358 # http://packages.debian.org/source/sid/xmacro
359 pi patch libXtst-devel
360 cd $(mktemp -d)
361 wget http://ftp.de.debian.org/debian/pool/main/x/xmacro/xmacro_0.3pre-20000911.orig.tar.gz
362 wget http://ftp.de.debian.org/debian/pool/main/x/xmacro/xmacro_0.3pre-20000911-6.diff.gz
363 ex *.gz
364 patch -p0 < xmacro_0.3pre-20000911-6.diff
365 cd xmacro-0.3pre-20000911.orig
366 make
367 sleep 1 # not sure why the following command couldn\'t find, so trying this
368 # no make install target
369 s cp -f xmacroplay xmacrorec xmacrorec2 /usr/local/bin
370 fi
371 ;;&
372 arch)
373 # like apt-cache
374 pi pkgfile
375 s pkgfile --update
376 if has_x; then
377 # libxtst is missing dep https://aur.archlinux.org/packages/xmacro/#news
378 pi xorg-server redshift xorg-xinput libxtst xmacro
379
380 # background:
381 # https://aur.archlinux.org/packages/xkbset/#comment-545419
382 cert=$(mktemp)
383 cat >$cert <<'EOF'
384 -----BEGIN CERTIFICATE-----
385 MIIJADCCB+igAwIBAgIRAIVAhZ0TMbQ5jTm0koI8X6YwDQYJKoZIhvcNAQELBQAw
386 djELMAkGA1UEBhMCVVMxCzAJBgNVBAgTAk1JMRIwEAYDVQQHEwlBbm4gQXJib3Ix
387 EjAQBgNVBAoTCUludGVybmV0MjERMA8GA1UECxMISW5Db21tb24xHzAdBgNVBAMT
388 FkluQ29tbW9uIFJTQSBTZXJ2ZXIgQ0EwHhcNMTUxMjA4MDAwMDAwWhcNMTgxMjA3
389 MjM1OTU5WjCBsTELMAkGA1UEBhMCVVMxDjAMBgNVBBETBTY1MjExMREwDwYDVQQI
390 EwhNaXNzb3VyaTERMA8GA1UEBxMIQ29sdW1iaWExHzAdBgNVBAkTFjExMDAgQ2Fy
391 cmllIEZyYW5ja2UgRHIxHzAdBgNVBAoTFlVuaXZlcnNpdHkgb2YgTWlzc291cmkx
392 CzAJBgNVBAsTAk1VMR0wGwYDVQQDExRmYWN1bHR5Lm1pc3NvdXJpLmVkdTCCASIw
393 DQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAN8Kap8hASpxQeqjHibGsCR1PBkh
394 nW9p5FkuhGpMW/3ko8QfxH0W1Hq2y2DTFUmq17kH3GfT3h9a7HcmUrC3q15PciOB
395 WR3j8u0bDfVppyAZXiHJzYGN7xHiPrZtFEGgwZd28+sW80WXTbGl+zKkmeZguGdH
396 AVGeWJEFK44ctLbpjHWCy+xNuhxJuL4olwPoV7WX9IUhceC0rxYQANhLGOJhbchj
397 Z76MA8dc2K3CZI5m7VqQwl09QSnCfz00afUr88ny9vj1S5k2ADS46gaE9O0lM6EY
398 z/uZvMizXN/4ko+hFBjCSt0Vhxjx0kYDSP15btiwh700ywBEubpvLROmd48CAwEA
399 AaOCBUswggVHMB8GA1UdIwQYMBaAFB4Fo3ePbJbiW4dLprSGrHEADOc4MB0GA1Ud
400 DgQWBBTTNWrSb+V/Ayy0i8W2LExMUisQMzAOBgNVHQ8BAf8EBAMCBaAwDAYDVR0T
401 AQH/BAIwADAdBgNVHSUEFjAUBggrBgEFBQcDAQYIKwYBBQUHAwIwZwYDVR0gBGAw
402 XjBSBgwrBgEEAa4jAQQDAQEwQjBABggrBgEFBQcCARY0aHR0cHM6Ly93d3cuaW5j
403 b21tb24ub3JnL2NlcnQvcmVwb3NpdG9yeS9jcHNfc3NsLnBkZjAIBgZngQwBAgIw
404 RAYDVR0fBD0wOzA5oDegNYYzaHR0cDovL2NybC5pbmNvbW1vbi1yc2Eub3JnL0lu
405 Q29tbW9uUlNBU2VydmVyQ0EuY3JsMHUGCCsGAQUFBwEBBGkwZzA+BggrBgEFBQcw
406 AoYyaHR0cDovL2NydC51c2VydHJ1c3QuY29tL0luQ29tbW9uUlNBU2VydmVyQ0Ff
407 Mi5jcnQwJQYIKwYBBQUHMAGGGWh0dHA6Ly9vY3NwLnVzZXJ0cnVzdC5jb20wggOg
408 BgNVHREEggOXMIIDk4IUZmFjdWx0eS5taXNzb3VyaS5lZHWCGmFkdmlzaW5nLmNv
409 YXMubWlzc291cmkuZWR1ghBhaGEubWlzc291cmkuZWR1ghZhbGwtY3JhZnQubWlz
410 c291cmkuZWR1gh1hbWVyaWNhbmJhc2tldHJ5Lm1pc3NvdXJpLmVkdYIXYW5kcmVh
411 cmlldy5taXNzb3VyaS5lZHWCFWFydGdyYWRzLm1pc3NvdXJpLmVkdYIYYmFja3Vw
412 LmNvYXMubWlzc291cmkuZWR1ghBiaWMubWlzc291cmkuZWR1ghZibG9nLmNvYXMu
413 bWlzc291cmkuZWR1ghVjb3dhbmxhYi5taXNzb3VyaS5lZHWCFWRhZS5zdGF0Lm1p
414 c3NvdXJpLmVkdYIRZGljZS5taXNzb3VyaS5lZHWCIGRpZ2l0YWxzdG9yeXRlbGxp
415 bmcubWlzc291cmkuZWR1gg9lYS5taXNzb3VyaS5lZHWCG2Vib29rLWRldi5tYXRo
416 Lm1pc3NvdXJpLmVkdYIXZWJvb2suZWNvbi5taXNzb3VyaS5lZHWCGGVuZ2xpc2g4
417 MDA2Lm1pc3NvdXJpLmVkdYIZZXVnZW5lZml0c2NoLm1pc3NvdXJpLmVkdYIYZXVy
418 b2t1bHR1cmUubWlzc291cmkuZWR1ghNmY2RsYWIubWlzc291cmkuZWR1ghZnZW9t
419 dXNldW0ubWlzc291cmkuZWR1ghRoYXJzdGFkLm1pc3NvdXJpLmVkdYITbHVkd2ln
420 Lm1pc3NvdXJpLmVkdYIYbWFjaGluZXNob3AubWlzc291cmkuZWR1ghNtYWpvcnMu
421 bWlzc291cmkuZWR1ghBtZ2EubWlzc291cmkuZWR1ghdvcmdhbnByaW50Lm1pc3Nv
422 dXJpLmVkdYIUcGh5c2ljcy5taXNzb3VyaS5lZHWCFHBtLmNoZW0ubWlzc291cmku
423 ZWR1ghxyZWNydWl0aW5nLmVjb24ubWlzc291cmkuZWR1ghdyZXBlYy5lY29uLm1p
424 c3NvdXJpLmVkdYIUc2NhbmxhYi5taXNzb3VyaS5lZHWCFnNzc2MuY29hcy5taXNz
425 b3VyaS5lZHWCF3RlYWNoLmNvYXMubWlzc291cmkuZWR1ghd0b3B0ZWFjaGVyLm1p
426 c3NvdXJpLmVkdYIQdnNmLm1pc3NvdXJpLmVkdYIid2hpdGVwYXBlci5ncmFkc2No
427 b29sLm1pc3NvdXJpLmVkdTANBgkqhkiG9w0BAQsFAAOCAQEAQutYVAqG7MpmG2Nu
428 Z/UypjYkN4JvwRbKBpTrce2IT/Sy29x6chBbyD+0WE6QORBtaUHuzE1KoXqpnF4M
429 QrkKw0oBAC6x9dISoomq0DkIndtoBYYLaxSoII6F4OGWgF7pQ/7MiCBYzsKQpn9t
430 aofMcTfvnCjq+MCIaeYnUKBVww0lOJlUxZGKxFJvRpf78HfbBauojjRO2zXLZD/u
431 KMspbTfDaj5etIgWGShY2eml3N/SjAENmZYkcgDBYFyi8CckcEBAVzpH1+D+7Anz
432 txHSYDNHAYLv83MwbegApa1FwPqlG/4SdEU8G6e6Xf5GLC/6GPGVTUpr7o348OOO
433 lzGQzw==
434 -----END CERTIFICATE-----
435 -----BEGIN CERTIFICATE-----
436 MIIF+TCCA+GgAwIBAgIQRyDQ+oVGGn4XoWQCkYRjdDANBgkqhkiG9w0BAQwFADCB
437 iDELMAkGA1UEBhMCVVMxEzARBgNVBAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0pl
438 cnNleSBDaXR5MR4wHAYDVQQKExVUaGUgVVNFUlRSVVNUIE5ldHdvcmsxLjAsBgNV
439 BAMTJVVTRVJUcnVzdCBSU0EgQ2VydGlmaWNhdGlvbiBBdXRob3JpdHkwHhcNMTQx
440 MDA2MDAwMDAwWhcNMjQxMDA1MjM1OTU5WjB2MQswCQYDVQQGEwJVUzELMAkGA1UE
441 CBMCTUkxEjAQBgNVBAcTCUFubiBBcmJvcjESMBAGA1UEChMJSW50ZXJuZXQyMREw
442 DwYDVQQLEwhJbkNvbW1vbjEfMB0GA1UEAxMWSW5Db21tb24gUlNBIFNlcnZlciBD
443 QTCCASIwDQYJKoZIhvcNAQEBBQADggEPADCCAQoCggEBAJwb8bsvf2MYFVFRVA+e
444 xU5NEFj6MJsXKZDmMwysE1N8VJG06thum4ltuzM+j9INpun5uukNDBqeso7JcC7v
445 HgV9lestjaKpTbOc5/MZNrun8XzmCB5hJ0R6lvSoNNviQsil2zfVtefkQnI/tBPP
446 iwckRR6MkYNGuQmm/BijBgLsNI0yZpUn6uGX6Ns1oytW61fo8BBZ321wDGZq0GTl
447 qKOYMa0dYtX6kuOaQ80tNfvZnjNbRX3EhigsZhLI2w8ZMA0/6fDqSl5AB8f2IHpT
448 eIFken5FahZv9JNYyWL7KSd9oX8hzudPR9aKVuDjZvjs3YncJowZaDuNi+L7RyML
449 fzcCAwEAAaOCAW4wggFqMB8GA1UdIwQYMBaAFFN5v1qqK0rPVIDh2JvAnfKyA2bL
450 MB0GA1UdDgQWBBQeBaN3j2yW4luHS6a0hqxxAAznODAOBgNVHQ8BAf8EBAMCAYYw
451 EgYDVR0TAQH/BAgwBgEB/wIBADAdBgNVHSUEFjAUBggrBgEFBQcDAQYIKwYBBQUH
452 AwIwGwYDVR0gBBQwEjAGBgRVHSAAMAgGBmeBDAECAjBQBgNVHR8ESTBHMEWgQ6BB
453 hj9odHRwOi8vY3JsLnVzZXJ0cnVzdC5jb20vVVNFUlRydXN0UlNBQ2VydGlmaWNh
454 dGlvbkF1dGhvcml0eS5jcmwwdgYIKwYBBQUHAQEEajBoMD8GCCsGAQUFBzAChjNo
455 dHRwOi8vY3J0LnVzZXJ0cnVzdC5jb20vVVNFUlRydXN0UlNBQWRkVHJ1c3RDQS5j
456 cnQwJQYIKwYBBQUHMAGGGWh0dHA6Ly9vY3NwLnVzZXJ0cnVzdC5jb20wDQYJKoZI
457 hvcNAQEMBQADggIBAC0RBjjW29dYaK+qOGcXjeIT16MUJNkGE+vrkS/fT2ctyNMU
458 11ZlUp5uH5gIjppIG8GLWZqjV5vbhvhZQPwZsHURKsISNrqOcooGTie3jVgU0W+0
459 +Wj8mN2knCVANt69F2YrA394gbGAdJ5fOrQmL2pIhDY0jqco74fzYefbZ/VS29fR
460 5jBxu4uj1P+5ZImem4Gbj1e4ZEzVBhmO55GFfBjRidj26h1oFBHZ7heDH1Bjzw72
461 hipu47Gkyfr2NEx3KoCGMLCj3Btx7ASn5Ji8FoU+hCazwOU1VX55mKPU1I2250Lo
462 RCASN18JyfsD5PVldJbtyrmz9gn/TKbRXTr80U2q5JhyvjhLf4lOJo/UzL5WCXED
463 Smyj4jWG3R7Z8TED9xNNCxGBMXnMete+3PvzdhssvbORDwBZByogQ9xL2LUZFI/i
464 eoQp0UM/L8zfP527vWjEzuDN5xwxMnhi+vCToh7J159o5ah29mP+aJnvujbXEnGa
465 nrNxHzu+AGOePV8hwrGGG7hOIcPDQwkuYwzN/xT29iLp/cqf9ZhEtkGcQcIImH3b
466 oJ8ifsCnSbu0GB9L06Yqh7lcyvKDTEADslIaeSEINxhO2Y1fmcYFX/Fqrrp1WnhH
467 OjplXuXE0OPa0utaKC25Aplgom88L2Z8mEWcyfoB7zKOfD759AN7JKZWCYwk
468 -----END CERTIFICATE-----
469 -----BEGIN CERTIFICATE-----
470 MIIF3jCCA8agAwIBAgIQAf1tMPyjylGoG7xkDjUDLTANBgkqhkiG9w0BAQwFADCB
471 iDELMAkGA1UEBhMCVVMxEzARBgNVBAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0pl
472 cnNleSBDaXR5MR4wHAYDVQQKExVUaGUgVVNFUlRSVVNUIE5ldHdvcmsxLjAsBgNV
473 BAMTJVVTRVJUcnVzdCBSU0EgQ2VydGlmaWNhdGlvbiBBdXRob3JpdHkwHhcNMTAw
474 MjAxMDAwMDAwWhcNMzgwMTE4MjM1OTU5WjCBiDELMAkGA1UEBhMCVVMxEzARBgNV
475 BAgTCk5ldyBKZXJzZXkxFDASBgNVBAcTC0plcnNleSBDaXR5MR4wHAYDVQQKExVU
476 aGUgVVNFUlRSVVNUIE5ldHdvcmsxLjAsBgNVBAMTJVVTRVJUcnVzdCBSU0EgQ2Vy
477 dGlmaWNhdGlvbiBBdXRob3JpdHkwggIiMA0GCSqGSIb3DQEBAQUAA4ICDwAwggIK
478 AoICAQCAEmUXNg7D2wiz0KxXDXbtzSfTTK1Qg2HiqiBNCS1kCdzOiZ/MPans9s/B
479 3PHTsdZ7NygRK0faOca8Ohm0X6a9fZ2jY0K2dvKpOyuR+OJv0OwWIJAJPuLodMkY
480 tJHUYmTbf6MG8YgYapAiPLz+E/CHFHv25B+O1ORRxhFnRghRy4YUVD+8M/5+bJz/
481 Fp0YvVGONaanZshyZ9shZrHUm3gDwFA66Mzw3LyeTP6vBZY1H1dat//O+T23LLb2
482 VN3I5xI6Ta5MirdcmrS3ID3KfyI0rn47aGYBROcBTkZTmzNg95S+UzeQc0PzMsNT
483 79uq/nROacdrjGCT3sTHDN/hMq7MkztReJVni+49Vv4M0GkPGw/zJSZrM233bkf6
484 c0Plfg6lZrEpfDKEY1WJxA3Bk1QwGROs0303p+tdOmw1XNtB1xLaqUkL39iAigmT
485 Yo61Zs8liM2EuLE/pDkP2QKe6xJMlXzzawWpXhaDzLhn4ugTncxbgtNMs+1b/97l
486 c6wjOy0AvzVVdAlJ2ElYGn+SNuZRkg7zJn0cTRe8yexDJtC/QV9AqURE9JnnV4ee
487 UB9XVKg+/XRjL7FQZQnmWEIuQxpMtPAlR1n6BB6T1CZGSlCBst6+eLf8ZxXhyVeE
488 Hg9j1uliutZfVS7qXMYoCAQlObgOK6nyTJccBz8NUvXt7y+CDwIDAQABo0IwQDAd
489 BgNVHQ4EFgQUU3m/WqorSs9UgOHYm8Cd8rIDZsswDgYDVR0PAQH/BAQDAgEGMA8G
490 A1UdEwEB/wQFMAMBAf8wDQYJKoZIhvcNAQEMBQADggIBAFzUfA3P9wF9QZllDHPF
491 Up/L+M+ZBn8b2kMVn54CVVeWFPFSPCeHlCjtHzoBN6J2/FNQwISbxmtOuowhT6KO
492 VWKR82kV2LyI48SqC/3vqOlLVSoGIG1VeCkZ7l8wXEskEVX/JJpuXior7gtNn3/3
493 ATiUFJVDBwn7YKnuHKsSjKCaXqeYalltiz8I+8jRRa8YFWSQEg9zKC7F4iRO/Fjs
494 8PRF/iKz6y+O0tlFYQXBl2+odnKPi4w2r78NBc5xjeambx9spnFixdjQg3IM8WcR
495 iQycE0xyNN+81XHfqnHd4blsjDwSXWXavVcStkNr/+XeTWYRUc+ZruwXtuhxkYze
496 Sf7dNXGiFSeUHM9h4ya7b6NnJSFd5t0dCy5oGzuCr+yDZ4XUmFF0sbmZgIn/f3gZ
497 XHlKYC6SQK5MNyosycdiyA5d9zZbyuAlJQG03RoHnHcAP9Dc1ew91Pq7P8yF1m9/
498 qS3fuQL39ZeatTXaw2ewh0qpKJ4jjv9cJ2vhsE/zB+4ALtRZh8tSQZXq9EfX7mRB
499 VXyNWQKV3WKdwrnuWih0hKWbt5DHDAff9Yk2dDLWKMGwsAvgnEzDHNb842m1R0aB
500 L6KCq9NjRHDEjf8tM7qtj3u1cIiuPhnPQCjY/MiQu12ZIvVS5ljFH4gxQ+6IHdfG
501 jjxDah2nGN59PRbxYvnKkKj9
502 -----END CERTIFICATE-----
503 EOF
504 cat /etc/ssl/certs/ca-certificates.crt >> $cert
505 CURL_CA_BUNDLE=$cert pi xkbset
506 fi
507
508 ;;&
509 ubuntu|debian|fedora)
510 if has_x; then
511 if isdebian-stable; then
512 pi xkbset
513 else
514 # xkbset was in testing for quite a while, dunno
515 # why it\'s not anymore. Sometime I should check and
516 # see if it\'s back in testing, but the unstable package
517 # doesn\'t upgrade anything form testing, and it\'s tiny
518 # so I\'m not bothering to automate it.
519 pi xkbset/unstable
520 fi
521 fi
522 ;;&
523 esac
524
525 if has_x; then
526 pi xbindkeys
527 fi
528 pi cryptsetup lvm2
529 # enables trim for volume delete, other rare commands.
530 sudo $sed -ri 's/( *issue_discards\b).*/\1 = 1/' /etc/lvm/lvm.conf
531
532 if encrypted; then
533 if isdeb; then
534 sudo cp /usr/share/doc/util-linux/examples/fstrim.{service,timer} /etc/systemd/system
535 fi
536 # does weekly trim
537 sudo systemctl enable fstrim.timer
538 fi
539
540 dirs=(/mnt/{1,2,3,4,5,6,7,8,9})
541 s mkdir -p "${dirs[@]}"
542 s chown ian:ian "${dirs[@]}"
543
544
545 tu /etc/fstab <<'EOF'
546 /i/w /w none bind,noauto 0 0
547 /i/k /k none bind,noauto 0 0
548 EOF
549
550
551 if ! mountpoint /kr; then
552 s mkdir -p /kr
553 s chown ian:traci /kr
554 fi
555
556 if home_network; then
557 if [[ $HOSTNAME == treetowl ]]; then
558 tu /etc/fstab <<'EOF'
559 /k /kr none bind,noauto 0 0
560 EOF
561 else
562 tu /etc/fstab <<'EOF'
563 treetowl:/k /kr nfs noauto 0 0
564 EOF
565 fi
566 fi
567
568 s mkdir -p /q /i/{w,k}
569 for dir in /{i,w,k}; do
570 if mountpoint $dir; then continue; fi # already mounted
571 s mkdir -p $dir
572 s chown ian:ian $dir
573 done
574
575 # not needed for all hosts, but rather just keep it uniform
576 s mkdir -p /mnt/iroot
577
578 # debian auto mounting of multi-disk encrypted btrfs is busted. It is
579 # in jessie, and in stretch as of 11/26/2016 I have 4 disks in cryptab,
580 # based on 3 of those, it creates .device units for /dev/mapper/dev...
581 # then waits endlessly for them on bootup, after the /dev/mapper disks
582 # have already been created and exist. todo: create a simple repro
583 # for this in a vm and report it upstream.
584 if has_btrfs || home_network; then
585 pi nfs-common
586 s dd of=/root/imount <<'EOF'
587 #!/bin/bash
588 [[ $EUID == 0 ]] || exec sudo -E "$BASH_SOURCE" "$@"
589 set -eE -o pipefail
590 trap 'echo "$0:$LINENO:error: \"$BASH_COMMAND\" returned $?" >&2' ERR
591 for dir in /i /mnt/iroot /k /kr /w; do
592 if ! mountpoint $dir &>/dev/null && \
593 awk '{print $2}' /etc/fstab | grep -xF $dir &>/dev/null; then
594 if awk '{print $3}' /etc/fstab | grep -xF nfs &>/dev/null; then
595 mount $dir || echo "warning: failed to mount nfs on $dir"
596 else
597 mount $dir
598 fi
599 fi
600 done
601 EOF
602 s chmod +x /root/imount
603
604 s dd of=/etc/systemd/system/imount.service <<'EOF'
605 [Unit]
606 Description=Mount /i and related mountpoints
607
608 [Service]
609 Type=oneshot
610 ExecStart=/root/imount
611
612 [Install]
613 # note /kr needs networking, this target is the simplest way to
614 # time it when the network should be up, but not do something
615 # dumb like delay startup until the network is up. It happens
616 # at some time after network.target
617 WantedBy=multi-user.target
618 EOF
619 sudo systemctl daemon-reload # needed if the file was already there
620 sudo systemctl enable imount.service
621 sudo systemctl start imount.service
622 fi
623
624 dir=/nocow
625 if has_btrfs; then
626 if ! mountpoint $dir; then
627 subvol=/mnt/root/nocow
628 if [[ ! -e $subvol ]]; then
629 s btrfs subvolume create $subvol
630 s chown root:1000 $subvol
631 s chattr +C $subvol
632 fi
633
634 first_root_crypt=$(awk '$2 == "/" {print $1}' /etc/mtab)
635 tu /etc/fstab <<EOF
636 $first_root_crypt /nocow btrfs noatime,subvol=nocow 0 0
637 EOF
638 s mkdir -p $dir
639 s chown ian:ian $dir
640 s mount $dir
641 fi
642 else
643 sudo mkdir -p $dir
644 fi
645
646 # ssh and probably some other things care about parent directory
647 # ownership, and ssh doesn\'t allow any group writable parent
648 # directories, so we are forced to use a directory structure similar
649 # to home directories
650 s chown root:ian /q
651 s chmod 755 /q
652
653
654 # it comes with stretch and arch, but not jessie.
655 # propogate /etc/udev/hwdb.d
656 if which systemd-hwdb; then
657 s systemd-hwdb update
658 ser restart systemd-udev-trigger
659 fi
660
661
662 if isdeb; then
663 # I\'ve had problems with postfix on debian:
664 # on stretch, a startup ordering issue caused all mail to fail.
665 # postfix changed defaults to only use ipv6 dns, causing all my mail to fail.
666 # exim4 is default on debian, so I assume it would
667 # be packaged better to avoid these types of things.
668 # I haven\'t gotten around to getting a non-debian exim
669 # setup.
670 mail-setup exim4
671 else
672 mail-setup postfix
673 fi
674
675 if isubuntu; then
676 # disable crash report annoying crap
677 s dd of=/etc/default/apport <<<'enabled=0'
678 fi
679
680 # fai sets this an old way that doesn't work for stretch.
681 # no harm in setting it universally here.
682 # using debconf-set-selection, the area gets reset to ETC
683 # on my linode test machine after doing a dpkg-reconfigure, or a reinstall,
684 # so we are using expect :(
685 # I got a random error when running this, so I added a sleep
686 # rather than trying to write a whole detect and wait loop.
687 # E: Could not get lock /var/lib/dpkg/lock - open (11: Resource temporarily unavailable)
688 # E: Unable to lock the administration directory (/var/lib/dpkg/), is another process using it?
689 sleep 1
690 s apt-get -y install --no-install-recommends expect
691 s expect <<EOF
692 set force_conservative 0
693 spawn dpkg-reconfigure tzdata -freadline
694 expect -nocase timeout {exit 1} "Geographic area:"
695 send "12\r"
696 expect -nocase timeout {exit 1} "Time zone:"
697 send "11\r"
698 expect eof
699 exit
700 EOF
701
702
703 if has_x; then
704 if isarch; then
705 # install so it's build dependencies don't get removed.
706
707 # emacs git build is currently broken
708 if false; then
709 x=$(mktemp -d)
710 pushd $x
711 aurex emacs-git
712 makepkg -si --noconfirm
713 popd
714 rm -rf $x
715 else
716 pi emacs
717 fi
718 pi hunspell hunspell-en
719 else
720 if $recompile; then
721 /a/bin/buildscripts/emacs
722 else
723 /a/bin/buildscripts/emacs --no-r || /a/bin/buildscripts/emacs
724 fi
725 fi
726
727 # todo, figure this out for arch if we ever try out gnome.
728 if ! isarch; then
729 # install for multiple display managers in case we use one
730 if isdeb; then
731 dir=/etc/gdm3
732 elif isfedora; then
733 # fedora didn\'t have the 3.
734 dir=/etc/gdm
735 fi
736 s mkdir -p $dir/PostLogin
737 s command cp /a/bin/distro-setup/desktop-20-autostart.sh $dir/PostLogin/Default
738 s mkdir /etc/lightdm/lightdm.conf.d
739 s dd of=/etc/lightdm/lightdm.conf.d/12-ian.conf <<'EOF'
740 [SeatDefaults]
741 session-setup-script=/a/bin/distro-setup/desktop-20-autostart.sh
742 EOF
743 fi
744
745
746 pi ghc sakura
747 # todo, also note for work comp, scp opt/org-mode bin/build-scripts
748
749 # use the package manger version to install the cabal version
750 pi cabal-install
751 cabal update
752 PATH="$PATH:$HOME/.cabal/bin"
753
754 # todo, on older ubuntu I used cabal xmonad + xfce,
755 # see /a/bin/old-unused/xmonad-cabal.sh
756
757 # trying out the distros versions newer distros
758 pi xmonad
759 if isarch; then
760 # for displaying error messages.
761 # optional dependency in arch, standard elsewhere.
762 pi xorg-xmessage xmonad-contrib xorg-xsetroot xorg-xinit
763
764 # https://wiki.archlinux.org/index.php/Xinitrc
765 for homedir in /home/*; do
766 cp /etc/X11/xinit/xinitrc $homedir/.xinitrc
767 $sed -ri '/^ *twm\b/,$d' $homedir/.xinitrc
768 tee -a $homedir/.xinitrc <<'EOF'
769 /a/bin/desktop-20-autostart.sh
770 xsetroot -cursor_name left_ptr
771 exec xmonad
772 EOF
773 done
774 else
775 pi suckless-tools
776 fi
777 pi dmenu
778
779 if isdeb && (tp || x2); then
780 pi task-laptop
781 fi
782 fi
783
784 # the first pup command can kill off our /etc/ mod, so rerun this
785 /a/exe/ssh-emacs-setup
786 echo "$0: $(date): ending now"